MMFF/PositionConstraint.h
Go to the documentation of this file.
//
// Copyright (C) 2013 Paolo Tosco
//
// Copyright (C) 2004-2006 Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#include <RDGeneral/export.h>
#ifndef __RD_MMFFPOSITIONCONSTRAINT_H__
#define __RD_MMFFPOSITIONCONSTRAINT_H__
#include <iostream>
#include <ForceField/Contrib.h>
#include <Geometry/point.h>
namespace ForceFields {
namespace MMFF {
//! A position constraint of the type 0.5k * deltaX^2
class RDKIT_FORCEFIELD_EXPORT PositionConstraintContrib
: public ForceFieldContrib {
public:
PositionConstraintContrib() {}
//! Constructor
/*!
\param owner pointer to the owning ForceField
\param idx index of the atom in the ForceField's positions
\param minDispl minimum displacement
\param maxDispl maximum displacement
\param forceConst force constant
*/
PositionConstraintContrib(ForceField *owner, unsigned int idx,
double maxDispl, double forceConst);
~PositionConstraintContrib() override = default;
double getEnergy(double *pos) const override;
void getGrad(double *pos, double *grad) const override;
PositionConstraintContrib *copy() const override {
return new PositionConstraintContrib(*this);
}
private:
int d_atIdx{-1}; //!< index of the restrained atom
double d_maxDispl; //!< maximum allowed displacement
RDGeom::Point3D d_pos0; //!< reference position
double d_forceConstant; //!< force constant of the bond
};
} // namespace MMFF
} // namespace ForceFields
#endif
Contrib.h
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition: Contrib.h:18
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition: ForceField.h:79
ForceFields::MMFF::PositionConstraintContrib
A position constraint of the type 0.5k * deltaX^2.
Definition: MMFF/PositionConstraint.h:24
ForceFields::MMFF::PositionConstraintContrib::PositionConstraintContrib
PositionConstraintContrib()
Definition: MMFF/PositionConstraint.h:26
ForceFields::MMFF::PositionConstraintContrib::copy
PositionConstraintContrib * copy() const override
return a copy
Definition: MMFF/PositionConstraint.h:43
ForceFields::MMFF::PositionConstraintContrib::PositionConstraintContrib
PositionConstraintContrib(ForceField *owner, unsigned int idx, double maxDispl, double forceConst)
Constructor.
ForceFields::MMFF::PositionConstraintContrib::getEnergy
double getEnergy(double *pos) const override
returns our contribution to the energy of a position
ForceFields::MMFF::PositionConstraintContrib::getGrad
void getGrad(double *pos, double *grad) const override
calculates our contribution to the gradients of a position
ForceFields::MMFF::PositionConstraintContrib::~PositionConstraintContrib
~PositionConstraintContrib() override=default
RDGeom::Point3D
Definition: point.h:54
export.h
RDKIT_FORCEFIELD_EXPORT
#define RDKIT_FORCEFIELD_EXPORT
Definition: export.h:177
ForceFields
Definition: TorsionAngleM6.h:24
point.h